#ifndef REMINDERACTOR_H
#define REMINDERACTOR_H

#include <QDateTime>
#include "actor.h"

class MultiFactorActor: public Actor
{
private:

    Actor* factorActor_;
    QDateTime activationTime;
    uint preCancleMin_;

    bool factorDirection = true;

private slots:

    void factorActorSlot(uint8_t value);

public slots:

    virtual void setValue(uint8_t value);

public:

    MultiFactorActor(Actor* FactorActor = nullptr, const uint preCancleMin = 10, QObject *parent = nullptr);

    virtual QString getName() const;

    void setFactorActor(Actor* factorActor);
    Actor* getFactorActor(){return factorActor_;}
    void setFactorDirection(const bool direction){factorDirection = direction;}
    bool getFactorDirection(){return factorDirection;}
    uint getPreCancleTime(){return preCancleMin_;}
    void setPreCancleTime(uint minutes){preCancleMin_ = minutes;}

    virtual ~MultiFactorActor(){}

    virtual void store(QJsonObject& json);
    virtual void load(const QJsonObject& json, bool preserve);
};

#endif // REMINDERACTOR_H
