#ifndef MESSAGEITEM_H
#define MESSAGEITEM_H

#include <QMessageBox>

#include "item.h"
#include "../broadcast.h"

class MessageItem : public Item
{
Q_OBJECT
private:

    QString message_;
    QMessageBox* messageBox_ = nullptr;

    static BroadCast* broadCast_;

private slots:

    void closeMessageBox();

public:

    virtual void setValue(uint8_t value);

public:

    MessageItem(uint32_t itemIdIn = QRandomGenerator::global()->generate(), QString name = "Item", uint8_t value = 0,  QObject *parent = nullptr);
    MessageItem(const ItemData& itemData,  QObject *parent = nullptr);
    ~MessageItem();

    void setMessage(const QString& in);
    QString getMessage();

    virtual void store(QJsonObject& json);
    virtual void load(const QJsonObject& json, const bool preserve = false);
};

#endif // MESSAGEITEM_H
