#ifndef REGULATORWDIGET_H
#define REGULATORWDIGET_H

#include <QWidget>
#include "../../actors/regulator.h"

namespace Ui {
class RegulatorWdiget;
}

class RegulatorWdiget : public QWidget
{
    Q_OBJECT

    Regulator* regulator_;
    SensorStore* sensors_;

public:
    explicit RegulatorWdiget(Regulator* regulator, SensorStore* sensors = nullptr, QWidget *parent = nullptr);
    ~RegulatorWdiget();

private slots:

    void setPoint(double in);
    void setBand(double band);
    void setSensor(const QModelIndex &index);

private:
    Ui::RegulatorWdiget *ui;
};

#endif // REGULATORWDIGET_H
