#include "itemcreationdialog.h"
#include "ui_itemcreationdialog.h"

#include "itemsettingswidgets/messageitemsettingswidget.h"

ItemCreationDialog::ItemCreationDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ItemCreationDialog)
{
    ui->setupUi(this);
    std::shared_ptr<MessageItem> messageItem(new MessageItem);
    item = messageItem;
    widget = new MessageItemSettingsWidget(messageItem, this);
    ui->verticalLayout->addWidget(widget);
    connect(ui->comboBox, &QComboBox::currentTextChanged, this, &ItemCreationDialog::itemTypeChanged);
    connect(ui->lineEdit, &QLineEdit::textChanged, this, &ItemCreationDialog::itemNameChanged);
}

ItemCreationDialog::~ItemCreationDialog()
{
    delete ui;
    delete widget;
}

void ItemCreationDialog::itemTypeChanged(const QString& type)
{
    ui->verticalLayout->removeWidget(widget);
    delete widget;
    if(type == "Message")
    {
        std::shared_ptr<MessageItem> messageItem(new MessageItem);
        item = messageItem;
        widget = new MessageItemSettingsWidget(messageItem, this);
        ui->verticalLayout_2->addWidget(widget);
    }
}

void ItemCreationDialog::itemNameChanged(const QString& name)
{
    if(item)
    {
        item->setName(name);
    }
}

